<?php

$treasuresObj = new treasures();

class Treasures {

    public $mDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;

    public function __construct() {
        global $Config; // استخدام المتغير العالمي
        $this->mDb = new Iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = defined('LANGUAGE') ? LANGUAGE : 'ar'; // التحقق من وجود الثابتة
    }

    public function getTreasures($aStart, $aLimit, $sort, $type, $searchName, $searchDateFrom, $searchDateTo) {

        $sql = "SELECT t.*  , u.user_name AS 'addedBy' FROM treasures t";

        $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";
        $sql .= " WHERE t.id > 0    ";

        $sql .= $searchName ? ' AND ( t.`name` like "%' . $searchName . '%" ) ' : '';
        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        $res = $this->mDb->getAll($sql);

        //  echo $sql; die();
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $data = $this->getBalaceForTreasury($res[$i]['id']);

                $res[$i]['sum_balance'] = $data['addition'] - $data['remove'];
            }
        }
        return $res;
    }

    public function getSearchTreasuresCount($sort, $type, $searchName, $searchDateFrom, $searchDateTo) {
        $sql = "SELECT COUNT(DISTINCT t.`id`) as 'result_count' FROM treasures t ";
        $sql .= " WHERE t.`id` > 0";
        $sql .= $searchName ? ' AND ( t.`name` like "%' . $searchName . '%"  ) ' : '';
        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    public function getBalaceForTreasury($treasure_id) {
        $sql = "SELECT sum(balance) as 'count' FROM `treasures_balances`  where treasure_id ='{$treasure_id}'   and type ='add'  ";
        $res['addition'] = $this->mDb->getOne($sql);

        $sql = "SELECT sum(`balance`) as 'count' FROM `treasures_balances`  where treasure_id ='{$treasure_id}' and type ='remove'  ";
        $res['remove'] = $this->mDb->getOne($sql);

        return $res;
    }

    public function getTreasuresCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `treasures`";
        return $this->mDb->getOne($sql);
    }

    public function addEditTreasury($temp) {
        global $userObj;
        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `treasures` SET ";
            foreach ($this->mDb->getCols('treasures', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'treasures_balances') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                $this->addTreasures_balances($id, $temp['treasures_balances']);

                if (!$temp['account_code']) {

                    $accountInfo = $this->getAccountIdByTypeSafes('safes');

                    if ($accountInfo) {
                        $accountInfo['admin_id'] = $res[$i]['admin_id'];
                        $account_code = $userObj->addAccount($accountInfo);
                        $this->updateAccountIdInSafes($account_code, $id);
                    }
                }
                # code...
            }
            return $res;
        } else {

            $sql = "UPDATE `treasures` SET ";
            foreach ($this->mDb->getCols('treasures', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'treasures_balances') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {
                if (!$temp['account_code']) {

                    $accountInfo = $this->getAccountIdByTypeSafes('safes');

                    if ($accountInfo) {
                        $accountInfo['admin_id'] = $res[$i]['admin_id'];
                        $account_code = $userObj->addAccount($accountInfo);
                        $this->updateAccountIdInSafes($account_code, $temp['id']);
                    }
                }
            }


            return $res;
        }
    }

    public function getAccountIdByTypeSafes($type) {

        $sql = "SELECT   a.id as parent,a.code,'1' as account_type,'safes' as mode ,(SELECT count(id) FROM `{$this->mPrefix}accounts` WHERE parent = a.id) as code_count  FROM `{$this->mPrefix}accounts_routing_list` arl ";
        $sql .= " LEFT JOIN `accounts` a ON a.code = arl.account_code ";
        $sql .= "WHERE arl.routing_key = '{$type}' ";

        $res = $this->mDb->getRow($sql);
        $res['code'] = $res['code'] . ($res['code_count'] > '0' ? +$res['code_count'] + 1 : '1');
        $res['type'] = 'debtor';

        unset($res['code_count']);
//        echo $sql;
        return $res;
    }

    public function updateAccountIdInSafes($account_code, $id) {
        $sql = " UPDATE  `treasures` SET `account_code` = '{$account_code}' ";
        $sql .= " WHERE `id` = '{$id}'  ";
//         echo $sql."<hr>";
        return $this->mDb->query($sql);
    }

    public function addTreasures_balances($id, $treasures_balances, $date_added = '') {

        $dateTime = $date_added ? $date_added : $this->dateTime;
        $treasures_balances['treasure_id'] = $id;
        $sql = "INSERT INTO `treasures_balances` SET ";
        foreach ($this->mDb->getCols('treasures_balances', $treasures_balances) as $k => $v) {
            $sql .= ($k == 'sum_balance' || $k == 'treasures_balances' || $k == 'sum_balance_after_balance') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$dateTime}' ";
        $sql .= $treasures_balances['date_treasures'] == '' || !$treasures_balances['date_treasures'] || $treasures_balances['date_treasures'] == null ? "   , `date_treasures` = '{$this->dateTime}' " : " ";
        // echo $sql ; die();
        return $this->mDb->query($sql);
    }

    public function deleteTreasures_balances($for_id, $for_type) {

        $sql = "DELETE From `{$this->mPrefix}treasures_balances`   ";
        $sql .= "where for_id ='{$for_id}'  AND  for_type ='{$for_type}'   ";
        $this->mDb->query($sql);
    }

    public function getOneTreasury($id) {
        $sql = "SELECT * FROM `treasures`";
        $sql .= " WHERE `id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,title FROM `treasury_langs`";
            $sql .= " WHERE `treasure_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);
        }
        // echo "<pre>";print_r($res);die();
        return $res;
    }

    public function getOneTreasuryDetails($id) {

        $sql = "SELECT t.* , u.user_name AS 'addedBy' FROM `treasures` t";
        $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";
        $sql .= " WHERE t.`id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {

            $data = $this->getBalaceForTreasury($id);
            $res['sum_balance'] = $data['addition'] - $data['remove'];
            $res['treasures_balances'] = $this->getAllTreasures_balances($id);
        }
        // echo "<pre>";print_r($res);die();
        return $res;
    }

    public function getAllTreasures_balances($id) {
        $sql = "SELECT t.* , u.user_name AS 'addedBy' FROM `treasures_balances` t";

        $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";

        $sql .= " WHERE t.`treasure_id` = '{$id}'  order by t.id  desc";
        return $this->mDb->getAll($sql);
    }

    public function deleteTreasury($ids) {
        $sql = "DELETE FROM `treasures` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }

        return $this->mDb->query($sql);
    }

    public function deleteBalanceTreasures($ids) {
        $sql = "DELETE FROM `treasures_balances` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }

        return $this->mDb->query($sql);
    }

    public function getBalanceTreasures($aStart, $aLimit, $sort, $type, $searchType, $searchDateFrom, $searchDateTo, $searchVoucher_clause_id, $searchId) {

        if (
                !$searchType &&
                !$searchDateFrom &&
                !$searchDateTo &&
                !$searchVoucher_clause_id
        ) {

            $searchDateFrom = $this->mConfig['limit_show_data_from'];
            //   p($this->mConfig);
        }


        $responce = array();
        $responce['sum_balance_remove'] = 0;
        $responce['sum_balance_addition'] = 0;
        if ($searchType == 'add' || !$searchType) {
            $sql = "SELECT  sum(t.balance) FROM treasures_balances t";
            $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";
            $sql .= " LEFT JOIN `vouchers` v ON v.id = t.for_id AND ( t.for_type ='get-voucher' || t.for_type ='cashing-voucher') ";
            $sql .= " LEFT JOIN `voucher_clauses` vc ON vc.id = v.voucher_clause_id ";
            $sql .= " WHERE t.id > 0  and  t.type ='add'   ";
            $sql .= $searchId ? " AND   t.`treasure_id`  ='{$searchId}'  " : '';
            $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
            $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
            $sql .= $searchVoucher_clause_id ? " AND (v.`voucher_clause_id` ='{$searchVoucher_clause_id}' ) " : '';
            // echo $sql;die();
            $responce['sum_balance_addition'] = $this->mDb->getOne($sql);
            //  echo  $responce;
        }
        if ($searchType == 'remove' || !$searchType) {
            $sql = "SELECT  sum(t.balance)  FROM treasures_balances t";
            $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";
            $sql .= " LEFT JOIN `vouchers` v ON v.id = t.for_id AND ( t.for_type ='get-voucher' || t.for_type ='cashing-voucher') ";
            $sql .= " LEFT JOIN `voucher_clauses` vc ON vc.id = v.voucher_clause_id ";
            $sql .= " WHERE t.id > 0 and t.type ='remove'   ";
            $sql .= $searchId ? " AND   t.`treasure_id`  ='{$searchId}'  " : '';
            $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
            $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
            $sql .= $searchVoucher_clause_id ? " AND (v.`voucher_clause_id` ='{$searchVoucher_clause_id}' ) " : '';

            $responce['sum_balance_remove'] = $this->mDb->getOne($sql);
        }

        $responce['sum_balance'] = $responce['sum_balance_addition'] - $responce['sum_balance_remove'];

        $responce['treasure_data'] = $this->getOneTreasury($searchId);

        $sql = "SELECT t.*  , u.user_name AS 'addedBy',v.note as  voucher_note ,v.for_id as v_for_id ,v.for_type as v_for_type,vc.name as voucher_clause_name   FROM treasures_balances t";

        $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";

        $sql .= " LEFT JOIN `vouchers` v ON v.id = t.for_id AND ( t.for_type ='get-voucher' || t.for_type ='cashing-voucher') ";

        $sql .= " LEFT JOIN `voucher_clauses` vc ON vc.id = v.voucher_clause_id ";

        $sql .= " WHERE t.id > 0    ";
        $sql .= $searchId ? " AND   t.`treasure_id`  ='{$searchId}'  " : '';

        $sql .= $searchType ? " AND   t.`type`  ='{$searchType}'  " : '';
        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchVoucher_clause_id ? " AND (v.`voucher_clause_id` ='{$searchVoucher_clause_id}' ) " : '';

        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['sum_balance_remove'] = 0;
                $res[$i]['sum_balance_addition'] = 0;
                if ($searchType == 'add' || !$searchType) {
                    $sql = "SELECT  sum(t.balance) FROM treasures_balances t";
                    $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";
                    $sql .= " LEFT JOIN `vouchers` v ON v.id = t.for_id AND ( t.for_type ='get-voucher' || t.for_type ='cashing-voucher') ";
                    $sql .= " LEFT JOIN `voucher_clauses` vc ON vc.id = v.voucher_clause_id ";
                    $sql .= " WHERE t.id <= '{$res[$i]['id']}'  and t.type ='add'   ";
                    $sql .= $searchId ? " AND   t.`treasure_id`  ='{$searchId}'  " : '';
                    $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
                    $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
                    $sql .= $searchVoucher_clause_id ? " AND (v.`voucher_clause_id` ='{$searchVoucher_clause_id}' ) " : '';
                    $res[$i]['sum_balance_addition'] = $this->mDb->getOne($sql);
                }
                if ($searchType == 'remove' || !$searchType) {
                    $sql = "SELECT  sum(t.balance)  FROM treasures_balances t";
                    $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";
                    $sql .= " LEFT JOIN `vouchers` v ON v.id = t.for_id AND ( t.for_type ='get-voucher' || t.for_type ='cashing-voucher') ";
                    $sql .= " LEFT JOIN `voucher_clauses` vc ON vc.id = v.voucher_clause_id ";
                    $sql .= " WHERE t.id <= '{$res[$i]['id']}' and t.type ='remove'   ";
                    $sql .= $searchId ? " AND   t.`treasure_id`  ='{$searchId}'  " : '';
                    $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
                    $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
                    $sql .= $searchVoucher_clause_id ? " AND (v.`voucher_clause_id` ='{$searchVoucher_clause_id}' ) " : '';

                    $res[$i]['sum_balance_remove'] = $this->mDb->getOne($sql);
                }

                $res[$i]['sum_balance'] = $res[$i]['sum_balance_addition'] - $res[$i]['sum_balance_remove'];
            }
        }



        if (count($res) > 0) {
            $responce['data'] = $res;
            return $responce;
        }
        //    echo $sql; die();
    }

    public function getSearchBalanceTreasuresCount($sort, $type, $searchType, $searchDateFrom, $searchDateTo, $searchVoucher_clause_id, $searchId) {

        if (
                !$searchType &&
                !$searchDateFrom &&
                !$searchDateTo &&
                !$searchVoucher_clause_id
        ) {

            $searchDateFrom = $this->mConfig['limit_show_data_from'];
            //   p($this->mConfig);
        }



        $sql = "SELECT COUNT(DISTINCT t.`id`) as 'result_count' FROM treasures_balances t ";
        $sql .= " LEFT JOIN `vouchers` v ON v.id = t.for_id AND (t.for_type ='get-voucher' || t.for_type ='cashing-voucher') ";
        $sql .= " LEFT JOIN `voucher_clauses` vc ON vc.id = v.voucher_clause_id ";
        $sql .= " WHERE t.`id` > 0";
        $sql .= $searchId ? " AND   t.`treasure_id`  ='{$searchId}'  " : '';
        $sql .= $searchType ? " AND   t.`type`  ='{$searchType}'  " : '';
        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";

        $sql .= $searchVoucher_clause_id ? " AND (v.`voucher_clause_id` ='{$searchVoucher_clause_id}' ) " : '';

        //  echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    public function getTreasures_balancesByType($for_type, $for_id) {
        $sql = "SELECT tb.* , t.name  FROM `treasures_balances` tb";
        $sql .= " LEFT JOIN `treasures` t ON t.id = tb.treasure_id ";

        $sql .= " WHERE tb.`for_type` = '{$for_type}' AND tb.`for_id` = '{$for_id}'  ";
        return $this->mDb->getRow($sql);
    }
}
