<?php

$cartsObj = new Carts();

class Carts {

    public $mDb;
    public $mConfig;
    public $lang_code;
    public $offersObj;
    public $dateTime;
    public $productsObj;
    public $userObj;
    public $treasuresObj;
    public $settings;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->productsObj = new Products();
        $this->userObj = new users();
        $this->treasuresObj = new treasures();
        $this->offersObj = new offers();
        $this->settings = new Configuration();

        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    public function getCartGroupId($cart_group_id) {
        global $settings;
        if ($cart_group_id == '0') {
            $cart_group_id = $settings->getlastCartGroupId();
            $cart_group_id = $cart_group_id + 1;
        }
        return $cart_group_id;
    }

    public function UpdateInvoiceEditIdCart($invoice_edit_id, $cart_id) {
        $sql = "UPDATE `carts` SET   `invoice_edit_id` = '{$invoice_edit_id}' ";
        $sql .= " WHERE id='{$cart_id}' and client_id = " . CLIENT['id'] . " and user_id = " . AFFILIATOR['id'] . "  ";
//         echo " $sql <hr>";
        // die($sql);
        return $this->mDb->query($sql);
    }

    public function UpdateCartInCol($key, $val, $cart_id) {
        $device_id = DEVICEID ? DEVICEID : '0';
        $client_id = CLIENT['id'] ?? '0';
        $affiliator_id = AFFILIATOR['id'];
        $sql = "UPDATE carts 
                SET $key = :val
                WHERE id = :cart_id  
                AND user_id = :affiliator_id ";
        $client_id ? $sql .= " AND client_id = :client_id " : '';
        $device_id ? $sql .= " AND device_id = :device_id " : '';
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':val', $val, PDO::PARAM_STR);
        $stmt->bindParam(':cart_id', $cart_id, PDO::PARAM_INT);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        $client_id ? $stmt->bindParam(':client_id', $client_id, PDO::PARAM_INT) : '';
        $device_id ? $stmt->bindParam(':device_id', $device_id, PDO::PARAM_STR) : '';
        return $stmt->execute();
    }

        public function addToCart($temp, $type = '') {
        $client_id = CLIENT['id'] ?? '0';
        $device_id = DEVICEID ? DEVICEID : '0';
        if ($client_id || $device_id) {
            $cart_info = $this->checkCart($temp['api_id_to']);
            if ($cart_info['id']) {
                $this->UpdateCartInCol('cart_group_id', $temp['cart_group_id'], $cart_info['id']);
                if ($temp['invoice_edit_id']) {
                    $this->UpdateInvoiceEditIdCart($temp['invoice_edit_id'], $cart_info['id']);
                    $this->UpdateCartInCol('type', 'editing_in_progress', $cart_info['id']);
                }
                $res = $this->addCartProduct($cart_info['id'], $temp);
                if ($res) {
                    $this->UpdateCartInCol('last_update', $this->dateTime, $cart_info['id']);
                }
                return $type == 'invoice_edit' ? $cart_info['id'] : $res;
            } else {
                $cart['user_id'] = AFFILIATOR['id'];
                $cart['client_id'] = $client_id;
                $cart['device_id'] = $device_id;
                $cart['set_from'] = SETFROM;
                $cart['invoice_edit_id'] = $temp['invoice_edit_id'];
                $cart['cart_group_id'] = $temp['cart_group_id'];
                $cart['type'] = 'packing_in_progress';
                // add
                $sql = "INSERT INTO `carts` SET ";
                foreach ($this->mDb->getCols('carts', $cart) as $k => $v) {
                    $sql .= ($k == 'city_name' or $k == 'country_name' or $k == 'product_items') ? "" : "`{$k}`='{$v}',";
                }
                $sql .= " `date_added` = '{$this->dateTime}',`last_update` = '{$this->dateTime}'";
                $res = $this->mDb->query($sql);

                if ($res) {
                    $id = $this->mDb->getLastInsertId();
                    $ress = $this->addCartProduct($id, $temp);
                    return $type == 'invoice_edit' ? $id : $ress;
                }
            }
        } else {
            return false;
        }
    }
   
    public function deleteFromProducsByCart_id($cart_id) {
        $sql = "DELETE FROM `cart_products` ";
        $sql .= " WHERE `cart_id` =  '{$cart_id}'  ";
        return $this->mDb->query($sql);
    }

    public function addCartProduct($id, $product_item) {
        if ($product_item['product_type_name'] && $product_item['product_id']) {
            $data = $this->cheackIFProductExist($id, $product_item['product_id'], $product_item['product_type_name']);
            if ($data['id']) {
                $item['quantity'] = $product_item['quantity'] + $data['quantity'];
                $item['key'] = $data['id'];
                return $this->updateCartItem($item);
            } else {
                $sql = "INSERT INTO `cart_products` SET ";
                foreach ($this->mDb->getCols('cart_products', $product_item) as $k => $v) {
                    if ($k == 'offer_id') {
                        $v = $v && $v != NULL ? $v : 0;
                    }
                    $sql .= ($k == 'coupon_id' or $k == 'product_name' or $k == 'store' or $k == 'product_barcode' or $k == 'product_code' or $k == 'commision_price_items' or $k == 'cart_id') ? "" : "{$k}='{$v}',";
                }
                $sql .= " cart_id = '{$id}' ,date_added = '{$this->dateTime}' ";
                $res = $this->mDb->query($sql);
                if ($res) {
                    return $this->mDb->getLastInsertId();
                }
            }
        }
    }

//    public function addCartProduct($id, $product_item) {
//
////       p($product_item);
//
//        if ($product_item['product_type_name'] && $product_item['product_id']) {
//
//            $data = $this->cheackIFProductExist($id, $product_item['product_id'], $product_item['product_type_name']);
//
//            if ($data['id']) {
//
//                $item['quantity'] = $product_item['quantity'] + $data['quantity'];
//
//                $item['key'] = $data['id'];
//                return $this->updateCartItem($item);
//            } else {
//
//                $sql = "INSERT INTO `cart_products` SET ";
//                foreach ($this->mDb->getCols('cart_products', $product_item) as $k => $v) {
////                    unset($v['coupon_id']);
//                    $v['offer_id'] = $v['offer_id'] && $v['offer_id'] != "null" ? $v['offer_id'] : 0;
////                    $v['coupon_id'] = $v['coupon_id'] ? $v['coupon_id'] : '0';
//                    $sql .= ($k == 'coupon_id' or $k == 'product_name' or $k == 'store' or $k == 'product_barcode' or $k == 'product_code' or $k == 'commision_price_items' or $k == 'cart_id') ? "" : "`{$k}`='{$v}',";
//                }
//                $sql .= " `cart_id` = '{$id}' ,`date_added` = '{$this->dateTime}' ";
////                   echo  $sql."<hr>";
//                // die();
//                $res = $this->mDb->query($sql);
//                if ($res) {
//                    return $this->mDb->getLastInsertId();
//                }
//            }
//        }
//    }

    public function updateCartItem($item) {
        $sql = "UPDATE `cart_products` 
                SET quantity = :quantity
                WHERE id = :key ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':quantity', $item['quantity'], PDO::PARAM_STR);
        $stmt->bindParam(':key', $item['key'], PDO::PARAM_INT);
        if ($stmt->execute()) {
            $this->UpdateCartInCol('last_update', $this->dateTime, $item['cart_id']);
            return $item['key'];
        }
    }

    public function updateCartShow($item) {
        $show_coupon_code = $item['couponInfo']['code'] ?? NULL;
        $sql = " UPDATE `carts` 
                SET 
                    show_discount = :total_discount,
                    show_total_price = :total_price,
                    show_coupon_discount = :total_coupon_discount,
                    show_coupon_code = :show_coupon_code,
                    show_total_quantity = :total_product_count
                WHERE id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':total_discount', $item['total_discount'], PDO::PARAM_STR);
        $stmt->bindParam(':total_price', $item['total_price'], PDO::PARAM_STR);
        $stmt->bindParam(':total_coupon_discount', $item['total_coupon_discount'], PDO::PARAM_STR);
        $stmt->bindParam(':show_coupon_code', $show_coupon_code, PDO::PARAM_STR);
        $stmt->bindParam(':total_product_count', $item['total_product_count'], PDO::PARAM_STR);
        $stmt->bindParam(':id', $item['id'], PDO::PARAM_INT);
        $stmt->execute();
    }

    public function emptyValueOffer($cart_id) {

        $sql = " UPDATE `cart_products` SET   `type` = NULL  ,  `value` = '0'  ,quantity_offer = '0'  ";
        $sql .= " WHERE   cart_id = '{$cart_id}' ";
        $this->mDb->query($sql);
    }

    public function emptyValueCoupon($cart_id) {

        $sql = " UPDATE `cart_products` SET   `coupon_type` = NULL  ,  `coupon_value` = '0'  ,quantity_coupon = '0'  ";
        $sql .= " WHERE   cart_id = '{$cart_id}' ";
        $this->mDb->query($sql);
    }

    public function emptyCouponInCartProducts($cart_id) {

        $sql = " UPDATE `cart_products` SET  `coupon_id`=0 ,`coupon_type` = NULL  ,  `coupon_value` = 0  ,`quantity_coupon` = 0  ";
        $sql .= " WHERE   `cart_id` = '{$cart_id}' ";
//         echo $sql.'<hr>';
        $res = $this->mDb->query($sql);
        if ($res) {
            $sql = " UPDATE `carts` SET   `show_coupon_code` = NULL   ";
            $sql .= " WHERE   `id` = '{$cart_id}' ";
//         echo $sql.'<hr>';
            $this->mDb->query($sql);
        }
    }

    public function updateValueOffer($of, $offer_id, $cart_id, $quantity_offer = '') {
        $of['maximum_discount_value'] = $of['maximum_discount_value'] ? $of['maximum_discount_value'] : 0;
        $sql = " UPDATE `cart_products` 
                SET   
                    type = :type  ,  
                    value = :value,  
                    maximum_discount_value = :maximum_discount_value ";
        $sql .= $quantity_offer ? "  ,quantity_offer = :quantity_offer  " : "  , quantity_offer =  quantity  ";
        $sql .= " WHERE cart_id = :cart_id  
                AND offer_id = :offer_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':type', $of['type'], PDO::PARAM_STR);
        $stmt->bindParam(':value', $of['value'], PDO::PARAM_STR);
        $stmt->bindParam(':maximum_discount_value', $of['maximum_discount_value'], PDO::PARAM_STR);
        $quantity_offer ? $stmt->bindParam(':quantity_offer', $quantity_offer, PDO::PARAM_STR) : '';
        $stmt->bindParam(':cart_id', $cart_id, PDO::PARAM_INT);
        $stmt->bindParam(':offer_id', $offer_id, PDO::PARAM_INT);
        $stmt->execute();
    }

    public function updateValueCoupon($of, $coupon_id, $cart_id, $quantity_coupon = '') {

        $of['coupon_maximum_discount_value'] = $of['coupon_maximum_discount_value'] ? $of['coupon_maximum_discount_value'] : 0;
        $sql = "UPDATE `cart_products` 
                SET   
                    coupon_type = :coupon_type ,  
                    coupon_value = :coupon_value,  
                    coupon_maximum_discount_value = :coupon_maximum_discount_value ";
        $sql .= $quantity_coupon ? "  , quantity_coupon = :quantity_coupon " : "  , quantity_coupon =  quantity  ";
        $sql .= " WHERE cart_id = :cart_id AND coupon_id = :coupon_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':coupon_type', $of['coupon_type'], PDO::PARAM_STR);
        $stmt->bindParam(':coupon_value', $of['coupon_value'], PDO::PARAM_STR);
        $stmt->bindParam(':coupon_maximum_discount_value', $of['coupon_maximum_discount_value'], PDO::PARAM_STR);
        $quantity_coupon ? $stmt->bindParam(':quantity_coupon', $quantity_coupon, PDO::PARAM_STR) : '';
        $stmt->bindParam(':cart_id', $cart_id, PDO::PARAM_INT);
        $stmt->bindParam(':coupon_id', $coupon_id, PDO::PARAM_INT);
        $stmt->execute();
    }

    public function updateValueOfferXY($of, $product_id, $cart_id, $quantity_offer = '') {
        $sql = " UPDATE `cart_products` SET   `type` = '{$of['type']}'  ,  `value` = '{$of['value']}'   ";
        $sql .= $quantity_offer ? "  , `quantity_offer` =  '{$quantity_offer}'   " : "  , quantity_offer =  quantity  ";
        $sql .= " WHERE   cart_id = '{$cart_id}'   AND `product_id` = '{$product_id}'   ";
        //  echo $sql; die();
        $this->mDb->query($sql);
    }

    // $this->updateValueOffer($of,$prod_offer[$i]['offer_id']);


    public function checkCart($api_id_to = '0') {
        $device_id = DEVICEID ? DEVICEID : '0';
        $client_id = CLIENT['id'] ?? '0';
        $affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT 
                    c.id ,
                    c.invoice_edit_id,
                    c.type   
                FROM carts c
                LEFT JOIN `cart_products` cp ON c.id = cp.cart_id
                WHERE (c.type='packing_in_progress' || c.type='editing_in_progress' ) 
                    AND cp.api_id_to = :api_id_to AND c.user_id = :affiliator_id ";
        if ($client_id) {
            $sql .= " AND c.client_id = :client_id ";
        } else {
            $sql .= " AND c.device_id = :device_id AND c.client_id = '0' ";
        }
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':api_id_to', $api_id_to, PDO::PARAM_STR);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        if ($client_id) {
            $stmt->bindParam(':client_id', $client_id, PDO::PARAM_INT);
        } else {
            $stmt->bindParam(':device_id', $device_id, PDO::PARAM_STR);
        }
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    public function getCart() {
        $device_id = DEVICEID ? DEVICEID : '0';
        $client_id = CLIENT['id'] ?? 0;
        $affiliator_id = AFFILIATOR['id'];
        global $productsObj;
        $res = $this->getCartData($client_id, $device_id, $affiliator_id);
        for ($r = 0; $r < count($res); $r++) {
            $res[$r]['details_store_external'] = $productsObj->getDetailsStoreExternalById($res[$r]['api_id_to']);
            $data = $this->getCartProducts($res[$r]['id'], $res[$r]['invoice_edit_id']);
            $res[$r]['product_items'] = $data['products'];
            $res[$r]['discount_array'] = $data['discount_array'];
            $res[$r]['product_items_show'] = array();
            $res[$r]['package_show'] = array();
            $res[$r]['total_discount_package'] = 0;
            $res[$r]['cart_products_groups'] = array();

            for ($i = 0; $i < count($res[$r]['product_items']); $i++) {
                $res[$r]['product_items'][$i]['favorites_id'] = $productsObj->getFavoritesId($res[$r]['product_items'][$i]['product_id']);
                if ($res[$r]['product_items'][$i]['package'] == '0') {
                    array_push($res[$r]['product_items_show'], $res[$r]['product_items'][$i]);
                } else {
                    $key = array_search($res[$r]['product_items'][$i]['offer_id'], array_column($res[$r]['discount_array'], 'offer_id'));
                    if ($key > 0 || $key === 0) {
                        if ($res[$r]['discount_array'][$key]['product_count'] >= $res[$r]['discount_array'][$key]['minimum_value_offer_application']) {
                            $newPackage = array(
                                "offer_id" => $res[$r]['discount_array'][$key]['offer_id'],
                                "discount" => $res[$r]['discount_array'][$key]['discount'],
                                "product_items_show" => [$res[$r]['product_items'][$i]]
                            );
                            $key_1 = array_search($res[$r]['product_items'][$i]['offer_id'], array_column($res[$r]['package_show'], 'offer_id'));
                            if ($key_1 > 0 || $key_1 === 0) {
                                array_push($res[$r]['package_show'][$key_1]['product_items_show'], $res[$r]['product_items'][$i]);
                            } else {
                                array_push($res[$r]['package_show'], $newPackage);
                                $res[$r]['total_discount_package'] += $res[$r]['discount_array'][$key]['discount'];
                            }
                        } else {
                            array_push($res[$r]['product_items_show'], $res[$r]['product_items'][$i]);

                            $data['total_discount'] = $data['total_discount'] - $res[$r]['discount_array'][$key]['discount'];
                        }
                    } else {
                        array_push($res[$r]['product_items_show'], $res[$r]['product_items'][$i]);
                    }
                }
                $res[$r]['product_items'][$i]['product_group_data'] = $productsObj->GetGroupData($res[$r]['product_items'][$i]['product_id']);
                $res[$r]['product_items_show'][$i]['product_group_data'] = $res[$r]['product_items'][$i]['product_group_data'];
                if (!empty($res[$r]['product_items'][$i]['product_group_data'])) {
                    $res[$r]['cart_products_groups'] = $this->handle_cart_products_groups(
                            $res[$r]['product_items'][$i]['product_group_data'],
                            $res[$r]['cart_products_groups'],
                            $res[$r]['product_items'][$i]['price'],
                            $res[$r]['product_items'][$i]['quantity']
                    );
                }
            }
            $res[$r]['shipping_type'] = $data['shipping_type'];
            $res[$r]['total_price_collected_from_customer'] = $data['total_price_collected_from_customer'];
            $res[$r]['drop_shipping_commission'] = $data['drop_shipping_commission'];
            $res[$r]['drop_shipping_commission_value'] = $data['drop_shipping_commission_value'];
            $res[$r]['profit'] = $data['profit'];
            $res[$r]['address_id'] = $data['address_id'];
            $res[$r]['shipment_id'] = $data['shipment_id'];
            $res[$r]['payment_method_type'] = $data['payment_method_type'];
            $res[$r]['payment_method_price'] = $data['payment_method_price'];
            $res[$r]['note'] = $data['note'];
            $res[$r]['InvoicesData'] = $data['InvoicesData'];
            $res[$r]['count_invoice_type'] = $data['count_invoice_type'];
            $res[$r]['use_credit'] = number_format($data['use_credit'], 1, '.', '');
            $res[$r]['total_discount'] = number_format($data['total_discount'], 1, '.', '');
            $res[$r]['total_discount_package'] = number_format($res[$r]['total_discount_package'], 1, '.', '');
            $res[$r]['coupon_discount_array'] = $data['coupon_discount_array'];
            $res[$r]['total_coupon_discount'] = number_format($data['total_coupon_discount'], 1, '.', '');
            $res[$r]['total_discount_on_products'] = number_format($data['total_discount_on_products'], 1, '.', '');
            $res[$r]['total_quantity_discount_on_products'] = number_format($data['total_quantity_discount_on_products'], 1, '.', '');
        }
        return $res;
    }

    public function cheackIFProductExist($cart_id, $product_id, $product_type_name) {
        $sql = "SELECT 
                    cp.id , 
                    cp.quantity   
                FROM `cart_products` cp
                WHERE cp.cart_id = :cart_id 
                AND cp.is_deleted = '0'  
                AND  cp.product_id = :product_id   
                AND  cp.product_type_name = :product_type_name ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(":cart_id", $cart_id, PDO::PARAM_INT);
        $stmt->bindParam(":product_id", $product_id, PDO::PARAM_INT);
        $stmt->bindParam(":product_type_name", $product_type_name, PDO::PARAM_STR);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    public function getTrademarkData($trademark_id) {
        $sql = "SELECT 
                    t.image ,
                    tl.title  
                FROM trademarks t
                LEFT JOIN trademark_langs tl 
                    ON t.id = tl.trademark_id  
                    AND  tl.lang_code = 'ar'
                WHERE t.id = :trademark_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(':trademark_id', $trademark_id, PDO::PARAM_STR);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    public function geCouponIdInCouponsUsed($mode_id, $mode) {
        $sql = "SELECT coupon_id  
                FROM coupons_used
                WHERE mode = :mode 
                AND mode_id = :mode_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(':mode', $mode, PDO::PARAM_STR);
        $stmt->bindValue(':mode_id', $mode_id, PDO::PARAM_STR);
        $stmt->execute();

        return $stmt->fetchColumn(0);
    }

    function getExceptDiscountedProducts($coupon_id) {
        $sql = "SELECT `except_discounted_products`  FROM coupons ";
        $sql .= " WHERE  id= '{$coupon_id}' ";
//           echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    public function updateCouponIdInCartProducts($coupon_id = '', $cart_id = '', $product_id = '') {
        $sql = "UPDATE `cart_products` 
                SET coupon_id = :coupon_id
                WHERE cart_id = :cart_id  
                AND product_id = :product_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':coupon_id', $coupon_id, PDO::PARAM_STR);
        $stmt->bindParam(':cart_id', $cart_id, PDO::PARAM_STR);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_STR);
        $stmt->execute();
    }

    public function getCartProducts($cart_id, $invoice_edit_id) {
        global $productsObj;
        global $invoicesObj;
        $affiliatorInfo = AFFILIATOR;
        $affiliator_stores = fetchArrayValue_from_dataBase($affiliatorInfo['stores'], 'id');

        $this->emptyOfferAndCouponValue($cart_id);

        if ($invoice_edit_id != '0') {
            $InvoicesData = $invoicesObj->getOneInvoice($invoice_edit_id);
            $ret['note'] = $InvoicesData['note'] ? $InvoicesData['note'] : '';
            $ret['count_invoice_type'] = $InvoicesData['count_invoice_type'];
            $ret['shipping_type'] = $InvoicesData['shipping_type'];
            $ret['shipment_id'] = $InvoicesData['shipment_id'];
            $ret['payment_method_type'] = $InvoicesData['payment_method_type'];
            $ret['payment_method_price'] = $InvoicesData['payment_method_price'];
            $ret['total_price_collected_from_customer'] = $InvoicesData['total_price_collected_from_customer'];
            $ret['drop_shipping_commission'] = $InvoicesData['drop_shipping_commission'];
            $ret['drop_shipping_commission_value'] = $InvoicesData['drop_shipping_commission_value'];
            $ret['profit'] = $InvoicesData['profit'];
            $ret['address_id'] = $InvoicesData['address_id'];
            $ret['use_credit'] = $InvoicesData['use_credit'];

            $couponUsedId = $this->geCouponIdInCouponsUsed($invoice_edit_id, 'invoice');
            if (!$couponUsedId) {
                $couponUsedId = $this->geCouponIdInCouponsUsed($cart_id, 'cart');
            }
        } else {
            $couponUsedId = $this->geCouponIdInCouponsUsed($cart_id, 'cart');
        }
        if ($couponUsedId) {
            $sql = "SELECT 
                        cp.id,
                        cp.product_id ,
                        cp.quantity,
                        p.trademark_id,
                        p.last_price_one,
                        p.price_one,
                        p.last_price_multi,
                        p.price_multi,
                        p.active 
                    FROM `cart_products` cp
                    LEFT JOIN `products` p ON p.id = cp.product_id
                    WHERE cp.cart_id = :cart_id AND cp.is_deleted='0' ";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindValue(':cart_id', $cart_id, PDO::PARAM_INT);
            $stmt->execute();
            $cart_cach = $stmt->fetchAll(PDO::FETCH_ASSOC);
            for ($c = 0; $c < count($cart_cach); $c++) {
                $cart_cach[$c]['quantityDiscount'] = $this->getProductQuantityDiscountByCart($cart_cach[$c]['product_id'], $cart_cach[$c]['quantity']);
                if (!($cart_cach[$c]['quantityDiscount']['unit_price'] > 0)) {
                    $cart_cach[$c]['last_price'] = null;
                    if ($affiliatorInfo['price_type'] == 'price_one' && $cart_cach[$c]['last_price_one'] > '0') {
                        $cart_cach[$c]['last_price'] = $cart_cach[$c]['price_one'];
                        $cart_cach[$c]['price_one'] = $cart_cach[$c]['last_price_one'];
                    }
                    if ($affiliatorInfo['price_type'] == 'price_multi' && $cart_cach[$c]['last_price_multi'] > '0') {
                        $cart_cach[$c]['last_price'] = $cart_cach[$c]['price_multi'];
                        $cart_cach[$c]['price_multi'] = $cart_cach[$c]['last_price_multi'];
                    }
                    $cart_cach[$c]['product_services'] = $productsObj->getProduct_services($cart_cach[$c]['product_id']);
                    $cart_cach[$c]['product_group_data'] = $productsObj->GetGroupData($cart_cach[$c]['product_id']);
                    $cart_cach[$c]['product_tags'] = $productsObj->getProductTags($cart_cach[$c]['product_id']);
                    $coupon_id = $productsObj->getProduct_coupon(
                            $cart_cach[$c]['product_id'],
                            $cart_cach[$c]['trademark_id'],
                            $cart_cach[$c]['product_services'],
                            $couponUsedId,
                            $cart_cach[$c]['product_group_data']['id'],
                            $cart_cach[$c]['product_tags']
                    );
                    $exceptDiscountedProducts = $this->getExceptDiscountedProducts($coupon_id);
                    if ($coupon_id && ($exceptDiscountedProducts || ($exceptDiscountedProducts == 0 && !$cart_cach[$c]['last_price']))) {
                        $this->updateCouponIdInCartProducts($coupon_id, $cart_id, $cart_cach[$c]['product_id']);
                    }
                }
            }
        }
        ////////////////////////////////////////////////// offer_discount //////////////////////////////////////////////////
        $prod_offer = $this->getCartOffer($affiliatorInfo, $cart_id);
        foreach ($prod_offer as &$offer) {
            $offer['quantityDiscount'] = $this->getProductQuantityDiscountByCart($offer['product_id'], $offer['quantity']);
            if (!($offer['quantityDiscount']['unit_price'] > 0)) {
                $offer_data = $this->offersObj->getOneOfferFull($offer['offer_id']);
                if ($offer['sum_diffrent_price'] > 0) {
                    $offer['price_sum'] = $offer['price_sum'] + $offer['sum_diffrent_price'];
                }
                if ($offer_data['offer_type'] == 'discount_percentage') {
                    //amount_of_prod 
                    if ($offer_data['offer_discount']['offer_application_type'] == 'amount_of_prod' && $offer['quantity_sum'] >= $offer_data['offer_discount']['minimum_value_offer_application']) {

                        $of['value'] = $offer_data['offer_discount']['value'];
                        $of['type'] = 'discount_percentage';
                        $of['maximum_discount_value'] = $offer_data['offer_discount']['maximum_discount_value'];

                        $this->updateValueOffer($of, $offer['offer_id'], $cart_id);
                    }
                    if ($offer_data['offer_discount']['offer_application_type'] == 'purchase_amount' && $offer['price_sum'] >= $offer_data['offer_discount']['minimum_value_offer_application']) {
                        $of['value'] = $offer_data['offer_discount']['value'];
                        $of['type'] = 'discount_percentage';
                        $of['maximum_discount_value'] = $offer_data['offer_discount']['maximum_discount_value'];
                        $this->updateValueOffer($of, $offer['offer_id'], $cart_id);
                    }
                    //purchase_amount
                }
                if ($offer_data['offer_type'] == 'discount_constant') {
                    if ($offer_data['offer_discount']['offer_application_type'] == 'amount_of_prod' && $offer['quantity_sum'] >= $offer_data['offer_discount']['minimum_value_offer_application']) {
                        $of['value'] = $offer_data['offer_discount']['value'];
                        $of['type'] = 'discount_constant';
                        $this->updateValueOffer($of, $offer['offer_id'], $cart_id);
                    }
                    if ($offer_data['offer_discount']['offer_application_type'] == 'purchase_amount' && $offer['price_sum'] >= $offer_data['offer_discount']['minimum_value_offer_application']) {
                        $of['value'] = $offer_data['offer_discount']['value'];
                        $of['type'] = 'discount_constant';
                        $this->updateValueOffer($of, $offer['offer_id'], $cart_id);
                    }
                }
            }
        }
        ////////////////////////////////////////////////// coupon_discount //////////////////////////////////////////////////
        $prod_coupon = $this->getCartCoupon($affiliatorInfo, $cart_id);
        foreach ($prod_coupon as &$copon) {
            $copon['quantityDiscount'] = $this->getProductQuantityDiscountByCart($copon['product_id'], $copon['quantity']);
            if (!($copon['quantityDiscount']['unit_price'] > 0)) {
                $coupon_data = $this->offersObj->getOneCouponFull($copon['coupon_id']);
                if ($copon['sum_diffrent_price'] > 0) {
                    $copon['price_sum'] = $copon['price_sum'] + $copon['sum_diffrent_price'];
                }
                if ($coupon_data['coupon_type'] == 'discount_percentage') {
                    //amount_of_prod 
                    if ($coupon_data['coupon_discount']['coupon_application_type'] == 'amount_of_prod' && $copon['quantity_sum'] >= $coupon_data['coupon_discount']['minimum_value_coupon_application']) {

                        $co['coupon_value'] = $coupon_data['coupon_discount']['coupon_value'];
                        $co['coupon_type'] = 'discount_percentage';
                        $co['coupon_maximum_discount_value'] = $coupon_data['coupon_discount']['coupon_maximum_discount_value'];
                        $coupon_price_sum = $copon['price_sum'];
                        $coupon_discount_value = (($coupon_price_sum * $co['coupon_value']) / 100);
                        if ($coupon_discount_value >= $co['coupon_maximum_discount_value']) {
                            $coupon_discount_value = $co['coupon_maximum_discount_value'];
                        }
                        $this->updateValueCoupon($co, $copon['coupon_id'], $cart_id);
                    }
                    if ($coupon_data['coupon_discount']['coupon_application_type'] == 'purchase_amount' && $copon['price_sum'] >= $coupon_data['coupon_discount']['minimum_value_coupon_application']) {
                        $co['coupon_value'] = $coupon_data['coupon_discount']['coupon_value'];
                        $co['coupon_type'] = 'discount_percentage';
                        $co['coupon_maximum_discount_value'] = $coupon_data['coupon_discount']['coupon_maximum_discount_value'];

                        $coupon_price_sum = $copon['price_sum'];
                        $coupon_discount_value = (($coupon_price_sum * $co['coupon_value']) / 100);
                        if ($coupon_discount_value >= $co['coupon_maximum_discount_value']) {
                            $coupon_discount_value = $co['coupon_maximum_discount_value'];
                        }

                        $this->updateValueCoupon($co, $copon['coupon_id'], $cart_id);
                    }
                }
                if ($coupon_data['coupon_type'] == 'discount_constant') {
                    if ($coupon_data['coupon_discount']['coupon_application_type'] == 'amount_of_prod' && $copon['quantity_sum'] >= $coupon_data['coupon_discount']['minimum_value_coupon_application']) {


                        $co['coupon_value'] = $coupon_data['coupon_discount']['coupon_value'];
                        $co['coupon_type'] = 'discount_constant';

                        $coupon_price_sum = $copon['price_sum'];
                        $coupon_discount_value = $co['coupon_value'];

                        $this->updateValueCoupon($co, $copon['coupon_id'], $cart_id);
                    }
                    if ($coupon_data['coupon_discount']['coupon_application_type'] == 'purchase_amount' && $copon['price_sum'] >= $coupon_data['coupon_discount']['minimum_value_coupon_application']) {
                        $co['coupon_value'] = $coupon_data['coupon_discount']['coupon_value'];
                        $co['coupon_type'] = 'discount_constant';

                        $coupon_price_sum = $copon['price_sum'];
                        $coupon_discount_value = $co['coupon_value'];

                        $this->updateValueCoupon($co, $copon['coupon_id'], $cart_id);
                    }
                }
            }
        }
        ////////////////////////////////////////////////// x_get_y //////////////////////////////////////////////////
        $prod_offer = $this->getCartx_get_y($affiliatorInfo, $cart_id);
        foreach ($prod_offer as &$x_get_y) {
            $x_get_y['quantityDiscount'] = $this->getProductQuantityDiscountByCart($x_get_y['product_id'], $x_get_y['quantity']);
            if (!($x_get_y['quantityDiscount']['unit_price'] > 0)) {
                $offer_data = $this->offersObj->getOneOfferFull($x_get_y['offer_id']);
                if ($x_get_y['sum_diffrent_price'] > 0) {
                    $x_get_y['price_sum'] = $x_get_y['price_sum'] + $x_get_y['sum_diffrent_price'];
                }
                if ($offer_data['offer_type'] == 'x_get_y' && $x_get_y['quantity_sum'] >= $offer_data['x_y_type']['x_quantity']) {
                    //amount_of_prod 
                    $of['value'] = $offer_data['x_y_type']['y_discount_type'] == 'free' ? '100' : $offer_data['x_y_type']['y_discount_percentage_value'];
                    $of['type'] = 'x_get_y_discount';
                    $of['quantity_sum'] = $x_get_y['quantity_sum'];

                    if ($offer_data['x_y_type']['y_types'] == 'products') {
                        $ret['types'] = 'products';
                        $ret['offer_products_ids'] = $offer_data['x_y_type']['y_ids'];
                    } else if ($offer_data['x_y_type']['y_types'] == 'services') {
                        $ret['types'] = 'services';
                        $ret['offer_services_ids'] = $offer_data['x_y_type']['y_ids'];
                    } else if ($offer_data['x_y_type']['y_types'] == 'trademarks') {
                        $ret['types'] = 'trademarks';
                        $ret['offer_trademarks_ids'] = $offer_data['x_y_type']['y_ids'];
                    } else if ($offer_data['x_y_type']['y_types'] == 'tags') {
                        $ret['types'] = 'tags';
                        $ret['offer_tags_ids'] = $offer_data['x_y_type']['y_ids'];
                    } else if ($offer_data['x_y_type']['y_types'] == 'product_group') {
                        $ret['types'] = 'product_group';
                        $ret['offer_product_group_ids'] = $offer_data['x_y_type']['y_ids'];
                    }
                    $this->getYProductInCart($ret, $cart_id, $offer_data);
                }
            }
        }
        $res = $this->getProductsInCart($cart_id);
        $discount = array();
        $coupon_discount = array();
        $discount_array = array();
        $coupon_discount_array = array();
        $ret['total_discount_on_products'] = 0;
        $ret['total_quantity_discount_on_products'] = 0;

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {

                $res[$i]['active'] = activeFormat($res[$i]['active']);
                $res[$i]['seller_name'] = $this->productsObj->getSellerNameBySellerId($res[$i]['seller_id']);
                $res[$i]['quantityDiscount'] = $this->getProductQuantityDiscountByCart($res[$i]['product_id'], $res[$i]['quantity']);
                if (isset($res[$i]['quantityDiscount']['unit_price']) && $res[$i]['quantityDiscount']['unit_price'] > 0) {
                    $res[$i]['quantity_last_' . $affiliatorInfo['price_type']] = $res[$i]['quantityDiscount']['unit_price'];
                }
                $trademark = $this->getTrademarkData($res[$i]['trademark_id']);
                $res[$i]['trademark_image'] = $trademark['image'];
                $res[$i]['trademark_title'] = $trademark['title'];

                $res[$i]['product_type_store_count'] = $this->productsObj->getProductStoresCount($res[$i]['product_id'], true, 'add');

                $res[$i]['store_amounts_product'] = $this->productsObj->getProductStoreAmounts($res[$i]['product_id'], $affiliator_stores, $res[$i]['product_type_name'], 'all_date');
                $res[$i]['store_amounts_product'] = $res[$i]['store_amounts_product'] ? $res[$i]['store_amounts_product'] : 0;

                if (isset($InvoicesData['invoice_items'])) {
                    if (count($InvoicesData['invoice_items']) > 0) {
                        for ($a = 0; $a < count($InvoicesData['invoice_items']); $a++) {
                            if ($InvoicesData['invoice_items'][$a]['product_id'] == $res[$i]['product_id']) {
                                $res[$i]['store_amounts_product'] = (+$res[$i]['store_amounts_product'] + +$InvoicesData['invoice_items'][$a]['quantity']);
                            }
                        }
                    }
                }
                $res[$i]['added_listiner_available'] = $this->productsObj->checkUserHaveListenToProductAvailability($res[$i]['product_id']) ? true : false;

                $res[$i]['last_price'] = null;
                $res[$i]['quantity_last_price'] = null;

                if ($affiliatorInfo['price_type'] == 'price' && $res[$i]['affiliator_price'] > 0) {
                    $res[$i]['price'] = $res[$i]['affiliator_price'];
                }
                $res[$i]['affiliator_commission'] = $res[$i]['affiliator_price'] ? $res[$i]['price'] - $res[$i]['price_multi'] : $res[$i]['commission'];

                if ($affiliatorInfo['price_type'] == 'price_one' && $res[$i]['last_price_one'] > '0') {
                    $res[$i]['last_price'] = $res[$i]['price_one'];
                    $res[$i]['price_one'] = $res[$i]['last_price_one'];
                }

                if ($affiliatorInfo['price_type'] == 'price_multi' && $res[$i]['last_price_multi'] > '0') {
                    $res[$i]['last_price'] = $res[$i]['price_multi'];
                    $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                }

                if ($res[$i]['last_price_multi'] > '0') {
                    $price_multi_last = $res[$i]['price_multi'];
                    $res[$i]['price_multi'] = $res[$i]['last_price_multi'];
                    $res[$i]['last_price_multi'] = $price_multi_last;
                }
                if ($res[$i]['quantity_last_' . $affiliatorInfo['price_type']] > 0) {
                    $quantity_last_price = $res[$i][$affiliatorInfo['price_type']];
                    $res[$i][$affiliatorInfo['price_type']] = $res[$i]['quantity_last_' . $affiliatorInfo['price_type']];
                    $res[$i]['quantity_last_price'] = $quantity_last_price;
                }

                if ($res[$i]['api_id_to']) {
                    if ($res[$i]['last_price_one'] > '0') {
                        $res[$i]['last_price'] = $res[$i]['price_one'];
                        $res[$i]['price_one'] = $res[$i]['last_price_one'];
                    }
                    $res[$i]['price'] = $res[$i]['price_one'];
                } else {
                    $res[$i]['price'] = $res[$i][$affiliatorInfo['price_type']];
                }

                if (($affiliatorInfo['price_type'] == "price_one" || $affiliatorInfo['price_type'] == "price_multi") && $res[$i]["last_price"] > '0') {
                    if (+$res[$i]["quantity_last_price"] > 0) {
                        $ret['total_discount_on_products'] += ($res[$i]["last_price"] - $res[$i]["quantity_last_price"]) * $res[$i]['quantity'];
                    } else {
                        $ret['total_discount_on_products'] += ($res[$i]["last_price"] - $res[$i]["price"]) * $res[$i]['quantity'];
                    }
                }
                if (+$res[$i]["quantity_last_price"] > 0) {
                    $ret['total_quantity_discount_on_products'] += (+$res[$i]["quantity_last_price"] - +$res[$i]["price"]) * +$res[$i]['quantity'];
                }
                $res[$i]['stores'] = $this->productsObj->getProductStores($res[$i]['product_id'], true);
                $res[$i]['images'] = $this->productsObj->getProductimgs($res[$i]['product_id']);
                $res[$i]['image'] = $res[$i]['images'][0]['name'];
                $res[$i]['original_image'] = $res[$i]['images'][0]['original_name'];

                $res[$i]['package'] = '0';
                if ($res[$i]['offer_id']) {
                    $res[$i]['offer_data'] = $this->offersObj->getOfferHandleInCart($res[$i]['offer_id']);
                    $res[$i]['package'] = $res[$i]['offer_data']['package'];
                }

                if ($res[$i]['coupon_id']) {
                    $res[$i]['coupon_data'] = $this->offersObj->getOneCoupon($res[$i]['coupon_id']);
                }
                //copuns
                if ($coupon_price_sum && $coupon_discount_value) {
                    $coupon_value = (($coupon_discount_value / $coupon_price_sum) * ($res[$i]['quantity_coupon'] * $res[$i]['price']));
                    $res[$i]['coupon_value'] = number_format($coupon_value, 2, '.', '');
                }

                if ($res[$i]['coupon_type'] == 'discount_constant') {

                    $coupon_discount['coupon_id'] = $res[$i]['coupon_id'];

                    $coupon_discount['coupon_discount'] = $res[$i]['coupon_value'];
                    $key = array_search($res[$i]['coupon_id'], array_column($coupon_discount_array, 'coupon_id'));
                    if ($key > 0 || $key === 0) {
                        $coupon_discount['coupon_discount'] = $coupon_discount_array[$key]['coupon_discount'] + $coupon_discount['coupon_discount'];
                        $coupon_discount_array[$key] = $coupon_discount;
                    } else {
                        array_push($coupon_discount_array, $coupon_discount);
                    }
                }

                if ($res[$i]['coupon_type'] == 'discount_percentage') {
                    $coupon_discount['coupon_id'] = $res[$i]['coupon_id'];
                    $coupon_discount['coupon_discount'] = $res[$i]['coupon_value'];
                    $key = array_search($res[$i]['coupon_id'], array_column($coupon_discount_array, 'coupon_id'));

                    if ($key > 0 || $key === 0) {
                        $coupon_discount['coupon_discount'] = $coupon_discount_array[$key]['coupon_discount'] + $coupon_discount['coupon_discount'];
                        $coupon_discount_array[$key] = $coupon_discount;
                    } else {
                        array_push($coupon_discount_array, $coupon_discount);
                    }
                }
                if ($res[$i]['type'] == 'discount_constant') {
                    $discount['offer_id'] = $res[$i]['offer_id'];
                    $discount['product_count'] = 1;
                    $discount['minimum_value_offer_application'] = $res[$i]['offer_data']['minimum_value_offer_application'];
                    $discount['package'] = $res[$i]['package'];
                    $discount['discount'] = $res[$i]['value'];
                    $key = array_search($res[$i]['offer_id'], array_column($discount_array, 'offer_id'));

                    if ($key > 0 || $key === 0) {
                        $discount['product_count'] = $discount['product_count'] + $discount_array[$key]['product_count'];
                        $discount_array[$key] = $discount;
                    } else {
                        array_push($discount_array, $discount);
                    }
                }
                if ($res[$i]['type'] == 'discount_percentage') {
                    $discount['offer_id'] = $res[$i]['offer_id'];
                    $discount['product_count'] = 1;
                    $discount['minimum_value_offer_application'] = $res[$i]['offer_data']['minimum_value_offer_application'];
                    $discount['package'] = $res[$i]['package'];
                    $discount['discount'] = $res[$i]['quantity_offer'] * $res[$i]['price'] * ($res[$i]['value'] / 100);
                    if ($discount['discount'] > $res[$i]['maximum_discount_value'] && $res[$i]['maximum_discount_value'] > 0) {
                        $discount['discount'] = $res[$i]['maximum_discount_value'];
                    }

                    $key = array_search($res[$i]['offer_id'], array_column($discount_array, 'offer_id'));

                    if ($key > 0 || $key === 0) {
                        $discount['product_count'] = $discount['product_count'] + $discount_array[$key]['product_count'];
                        $discount['discount'] = $discount_array[$key]['discount'] + $discount['discount'];
                        $discount_array[$key] = $discount;
                    } else {
                        array_push($discount_array, $discount);
                    }
                }
                if ($res[$i]['type'] == 'x_y_free') {
                    $res[$i]['new_price_discount'] = 0;
                    $discount['product_id'] = $res[$i]['product_id'];
                    $discount['discount'] = $res[$i]['price'];
                    array_push($discount_array, $discount);
                }
                if ($res[$i]['type'] == 'x_y_presentage') {
                    $discount['product_id'] = $res[$i]['product_id'];
                    $res[$i]['new_price_discount'] = $res[$i]['price'] * ($res[$i]['value'] / 100);
                    $discount['discount'] = $res[$i]['price'] * ($res[$i]['value'] / 100);
                    array_push($discount_array, $discount);
                }
                $res[$i]['offer_data'] = $res[$i]['offer_data'] ? $res[$i]['offer_data'] : null;
                $res[$i]['coupon_data'] = $res[$i]['coupon_data'] ? $res[$i]['coupon_data'] : null;
                $res[$i]['meta_url'] = (trim($res[$i]['meta_url']) ? processTitle($res[$i]['meta_url']) : processTitle($res[$i]['name']));
            }
        }

        $ret['total_discount'] = 0;
        $ret['total_quantity_discount'] = 0;
        $ret['total_coupon_discount'] = 0;

        for ($i = 0; $i < count($discount_array); $i++) {
            $discount_array[$i]['discount'] = number_format($discount_array[$i]['discount'], 1, '.', '');
            $ret['total_discount'] += $discount_array[$i]['discount'];
        }



        for ($c = 0; $c < count($coupon_discount_array); $c++) {
            $coupon_discount_array[$c]['coupon_discount'] = number_format($coupon_discount_array[$c]['coupon_discount'], 1, '.', '');
            $ret['total_coupon_discount'] += $coupon_discount_array[$c]['coupon_discount'];
        }
        $ret['discount_array'] = $discount_array;
        $ret['coupon_discount_array'] = $coupon_discount_array;

        $ret['products'] = $res;
        return $ret;
    }

    public function getProductQuantityDiscountByCart($product_id, $quantity = 0) {
        $affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT 
                    pqd.product_id,
                    pqd.quantity,
                    pqd.unit_price,
                    pqd.offer_price 
                FROM product_quantity_discount pqd
                WHERE pqd.product_id = :product_id 
                    AND pqd.affiliator_id = :affiliator_id
                    AND pqd.quantity != '1' 
                    AND pqd.quantity <= :quantity 
                ORDER BY pqd.quantity DESC LIMIT 1";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(':product_id', $product_id);
        $stmt->bindValue(':affiliator_id', $affiliator_id);
        $stmt->bindValue(':quantity', $quantity);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    public function getYProductInCart($offer_filter, $cart_id, $offer_data) {
        $sql = "SELECT  
                    cp.*,
                    p.price , 
                    p.price_gomla_gomla ,
                    p.price_multi , 
                    p.price_half ,
                    p.price_one ,
                    p.last_price_one,
                    p.last_price_multi ,
                    p.trademark_id , 
                    p.active 
                FROM `products` p
                LEFT JOIN `product_services` ps ON ps.product_id = p.id
                LEFT JOIN `cart_products` cp ON cp.product_id = p.id
                WHERE cp.cart_id = :id AND  ( cp.type is null )";
        $sql .= $offer_filter["types"] == "products" && $offer_filter["offer_products_ids"] ? " AND p.id   in  ({$offer_filter["offer_products_ids"]})  " : " ";
        $sql .= $offer_filter["types"] == "services" && $offer_filter["offer_services_ids"] ? " AND ps.service_id   in  ({$offer_filter["offer_services_ids"]})  " : " ";
        $sql .= $offer_filter["types"] == "trademarks" && $offer_filter["offer_trademarks_ids"] ? " AND p.trademark_id    in  ({$offer_filter["offer_trademarks_ids"]})  " : " ";
        $sql .= AFFILIATOR['price_type'] == 'price_one' ? " AND p.last_price_one > '0' " : " ";
        $sql .= AFFILIATOR['price_type'] == 'price_multi' ? " AND p.last_price_multi  > '0' " : " ";
        $sql .= "GROUP BY cp.product_id  HAVING sum(`cp`.quantity - `cp`.quantity_offer ) > 0   ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $cart_id);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $quantity = 0;
        foreach ($res as &$count) {
            $count['available_quantity_sum_y'] = $count['quantity'] - $count['quantity_offer'];
            $quantity += $count['available_quantity_sum_y'];
        }
        $available = $quantity - $offer_data['x_y_type']['x_quantity'];
        if ($res) {
            foreach ($res as &$offer) {
                if ($available > $offer['available_quantity_sum_y']) {
                    $available = $available - $offer['available_quantity_sum_y'];
                    $of['type'] = $offer_data['x_y_type']['y_discount_type'] == 'free' ? 'x_y_free' : 'x_y_presentage';
                    $of['value'] = $offer_data['x_y_type']['y_discount_percentage_value'];
                    $this->updateValueOfferXY($of, $offer['product_id'], $cart_id, $offer['available_quantity_sum_y']);
                }
                if ($available <= $offer['available_quantity_sum_y']) {

                    $of['type'] = $offer_data['x_y_type']['y_discount_type'] == 'free' ? 'x_y_free' : 'x_y_presentage';
                    $of['value'] = $offer_data['x_y_type']['y_discount_percentage_value'];
                    $this->updateValueOfferXY($of, $offer['product_id'], $cart_id, $available);
                }
            }
        }
    }

    public function getProductThatHaveAcceptConditions($cart_id) {
        $sql = "SELECT `cp`.* , `pl`.name as product_name ,p.product_barcode ,p.product_code  ,p.price , p.price_gomla_gomla ,p.price_multi , p.price_half ,p.price_one ,p.trademark_id,p.active  FROM `cart_products` cp ";
        $sql .= " LEFT JOIN `products` p ON p.id = cp.product_id";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = cp.product_id  AND   pl.`lang_code` = '{$this->lang_code}'";
        $sql .= " WHERE cp.cart_id = '{$cart_id}' ";
    }

    function getProduct_offer($product_id, $trademark_id, $product_services) {

        $now = date('Y-m-d');

        // offer_discount
        $sql = "SELECT p.id  ,p.priority  FROM `offers` p";
        $sql .= " LEFT JOIN `offer_discount` od ON p.id = od.offer_id ";
        $sql .= " WHERE   p.active ='1' AND (p.`affiliator_id` = '" . AFFILIATOR['id'] . "' ||  ( p.`affiliator_id` = '0' AND p.price_type ='" . AFFILIATOR['price_type'] . "' )) ";
        $sql .= " AND (p.`offer_start_date` <= '{$now}' ||  p.`offer_start_date` is Null      )  ";
        $sql .= " AND( p.`offer_end_date` >= '{$now}'  ||  p.`offer_end_date` is Null    ) ";
        $sql .= " AND ( p.`show_on`  = '" . SETFROM . "'  ||  p.`show_on`  = 'both') ";

        $sql .= ' AND  ((   od.apply_type_conditions = "cart" ) || ( od.`ids`  like "%,' . $product_id . ',%" AND  od.apply_type_conditions = "products" ) ';
        $sql .= '   || ( od.`ids`  like "%,' . $trademark_id . ',%" AND  od.apply_type_conditions = "trademarks" ) ';
        $sql .= '  ||( ( (od.`ids`  like "%,-1,%" ) ';
        for ($i = 0; $i < count($product_services); $i++) {
            $sql .= ' ||  (od.`ids`  like "%,' . $product_services[$i]['service_id'] . ',%" )  ';
        }
        $sql .= ' ) AND   od.apply_type_conditions = "services" ) )   ';

        $sql .= " ORDER BY p.priority desc limit 1 ";
        // echo  $sql;
        // die();
        $offer_discount = $this->mDb->getAll($sql);

        // offer_x_y
        $sql = "SELECT p.id  ,p.priority  FROM `offers` p";
        $sql .= " LEFT JOIN `offer_x_y` oxy ON p.id = oxy.offer_id ";
        $sql .= " WHERE   p.active ='1' AND (p.`affiliator_id` = '" . AFFILIATOR['id'] . "' ||  ( p.`affiliator_id` = '0' AND p.price_type ='" . AFFILIATOR['price_type'] . "' )) ";
        $sql .= " AND (p.`offer_start_date` <= '{$now}' ||  p.`offer_start_date` is Null       )  ";
        $sql .= " AND( p.`offer_end_date` >= '{$now}'  ||  p.`offer_end_date` is Null    ) ";
        $sql .= " AND ( p.`show_on`  = '" . SETFROM . "'  ||  p.`show_on`  = 'both') ";

        $sql .= ' AND ( ( oxy.`x_ids`  like "%,' . $product_id . ',%" AND  oxy.x_types = "products" ) ';
        $sql .= '   || ( oxy.`x_ids`  like "%,' . $trademark_id . ',%" AND  oxy.x_types = "trademarks" ) ';
        $sql .= '  ||( ( (oxy.`x_ids`  like "%,-1,%" ) ';
        for ($i = 0; $i < count($product_services); $i++) {
            $sql .= ' ||  (oxy.`x_ids`  like "%,' . $product_services[$i]['service_id'] . ',%" ) ';
        }
        $sql .= ' ) AND oxy. x_types = "services" ) )   ';
        $sql .= " ORDER BY p.priority desc limit 1 ";
        $offer_x_y = $this->mDb->getAll($sql);
        // echo  $sql;
        // die();
        if ($offer_discount[0]['priority'] > $offer_x_y[0]['priority']) {
            return $offer_discount[0]['id'];
        } else if ($offer_discount[0]['priority'] <= $offer_x_y[0]['priority']) {
            return $offer_x_y[0]['id'];
        } else {
            return '';
        }
        //  echo $sql;die();
    }

    public function emptyCart($item) {
        $device_id = DEVICEID ? DEVICEID : '0';
        if ($item['type'] == 'canceled') {

            $sql = "SELECT id   FROM `carts` where invoice_edit_id ='{$item['invoice_edit_id']}' and type='canceled' ";
            $a['cart_id'] = $this->mDb->getOne($sql);
            if ($a['cart_id']) {
                $this->deleteCart($a);
            }
        }
        $sql = "UPDATE `carts` SET  `type` = '{$item['type']}'  ";
        $sql .= $item['invoice_edit_id'] != '' ? ",invoice_edit_id='{$item['invoice_edit_id']}' " : "";
        $sql .= $item['invoice_id'] ? ",invoice_id='{$item['invoice_id']}' " : "";
        $sql .= $item['app_version'] ? ",`app_version`='{$item['app_version']}' " : "";
        if ($item['type'] == 'canceled') {
            $sql .= ",`show_total_price`='0',`show_discount`='0',`show_coupon_discount`='0',`show_coupon_code`=null,`show_total_quantity`='0'";
        }
        $sql .= " WHERE `id` IN ({$item['cart_id']})  and user_id = " . AFFILIATOR['id'] . "   ";
        $sql .= CLIENT['id'] ? " and  client_id = " . CLIENT['id'] . " " : "";
        $sql .= $device_id && !CLIENT['id'] ? " and  device_id = '{$device_id}' " : "";
        // p($sql);
        $res = $this->mDb->query($sql);
        if ($res) {
            if ($item['type'] == 'canceled') {
                $sql = "UPDATE `cart_products` SET   `is_deleted` = '1' , `cart_id`='{$item['cart_id']}'";
                $sql .= $item['app_version'] ? ",`app_version`='{$item['app_version']}' " : "";
                $sql .= " WHERE `cart_id` IN({$item['cart_id']})  ";
                // p($sql);
                $this->mDb->query($sql);
            }


            $this->UpdateCartInCol('last_update', $this->dateTime, $item['cart_id']);
        }
        return $res;
        // refund From Store 
        // echo "$sql";die();
    }

    public function deleteCartItem($item) {
        $sql = "UPDATE `cart_products` SET   `is_deleted` = '1' , `cart_id`='{$item['cart_id']}' ";
        $sql .= $item['app_version'] ? ",`app_version`='{$item['app_version']}' " : "";
        $sql .= " WHERE `id` = '{$item['key']}'  ";
        // p($sql);
        $res = $this->mDb->query($sql);
        if ($res) {
            $this->UpdateCartInCol('last_update', $this->dateTime, $item['cart_id']);
        }
        return $res;
        // refund From Store 
        // echo "$sql";die();
    }

//    public function deleteCartItem($item) {
//        $sql = "DELETE FROM `cart_products` ";
//        $sql .= " WHERE `id` = '{$item['key']}'  ";
//        // p($sql);
//        $res = $this->mDb->query($sql);
//        if ($res) {
//            $this->UpdateCartInCol('last_update', $this->dateTime);
//        }
//        return $res;
//        // refund From Store 
//        // echo "$sql";die();
//    }

    public function deleteCart($item) {
        $sql = "DELETE FROM `carts` ";
        $sql .= " WHERE `id` IN ({$item['cart_id']})  ";
        // p($sql);
        $res = $this->mDb->query($sql);
        if ($res) {
            $sql = "DELETE FROM `cart_products` ";
            $sql .= " WHERE `cart_id` IN ({$item['cart_id']})  ";
            // p($sql);
            $res = $this->mDb->query($sql);
        }
        return $res;
        // refund From Store 
        // echo "$sql";die();
    }

    public function getCart_productInfo($id) {
        $sql = "SELECT cp.product_id , cp.quantity , pl.name , p.price , cp.product_type_name,p.active  FROM `cart_products` cp ";
        $sql .= " LEFT JOIN `products` p ON p.id = cp.product_id";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND pl.lang_code ='{$this->lang_code}'";

        $sql .= " WHERE cp.`id` = '{$id}'   ";
//       p($sql);
        return $this->mDb->getRow($sql);
        // refund From Store 
        // echo "$sql";die();
    }

    public function getCartRow() {
        $client_id = CLIENT['id'] ?? 0;
        $affiliator_id = AFFILIATOR['id'];
        $sql = "SELECT c.*  
                FROM carts c 
                WHERE (c.type='packing_in_progress' || c.type='editing_in_progress' ) 
                    AND c.client_id = :client_id 
                    AND c.user_id = :affiliator_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':client_id', $client_id, PDO::PARAM_INT);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    public function getCartIdInInvoiceId($invoice_id) {
        $sql = "SELECT id  FROM `carts`   ";
        $sql .= " WHERE  invoice_id='{$invoice_id}' and client_id = " . CLIENT['id'] . " and user_id = " . AFFILIATOR['id'] . "  ";
        //      echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    public function getCartOffer($affiliatorInfo, $cart_id) {
        $sql = "SELECT 
                    p.price , 
                    p.price_gomla_gomla ,
                    p.price_multi , 
                    p.price_half ,
                    p.price_one ,
                    p.last_price_one,
                    p.last_price_multi ,
                    p.trademark_id  ,
                    sum(cp.quantity) as quantity_sum , 
                    sum( p.{$affiliatorInfo['price_type']} * cp.quantity  )  as price_sum ,  
                    cp.offer_id   , 
                    sum( (ap.price - p.price) * cp.quantity ) as sum_diffrent_price,
                    p.active,
                    cp.product_id,cp.quantity   
                FROM `cart_products` cp
                LEFT JOIN `products`  p ON p.id = cp.product_id
                LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id
                WHERE cp.cart_id = :cart_id AND offer_id > 0  and cp.is_deleted = '0' ";
        $sql .= $affiliatorInfo['price_type'] == 'price_one' ? " AND p.last_price_one < p.price_one " : " ";
        $sql .= $affiliatorInfo['price_type'] == 'price_multi' ? " AND p.last_price_multi < p.price_multi " : " ";
        $sql .= " GROUP BY cp.offer_id  ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->execute(array('cart_id' => $cart_id));
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getCartCoupon($affiliatorInfo, $cart_id) {
        $sql = "SELECT 
                    p.price , 
                    p.price_gomla_gomla ,
                    p.price_multi , 
                    p.price_half ,
                    p.price_one ,
                    p.last_price_one,
                    p.last_price_multi ,
                    p.trademark_id  ,
                    sum(cp.quantity) as quantity_sum  ,  
                    cp.coupon_id   , 
                    sum( (ap.price - p.price) * cp.quantity ) as sum_diffrent_price,
                    cp.product_id,cp.quantity, 
                    SUM(
                        CASE WHEN 
                            p.last_{$affiliatorInfo['price_type']} > 0 
                        THEN 
                            p.last_{$affiliatorInfo['price_type']} * cp.quantity 
                        ELSE 
                            p." . AFFILIATOR['price_type'] . " * cp.quantity 
                        END
                    ) AS price_sum, 
                    p.active
                    FROM `cart_products` cp
                    LEFT JOIN `products`  p ON p.id = cp.product_id
                    LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id
                    WHERE cp.cart_id = :cart_id AND coupon_id > 0  and cp.is_deleted = '0' 
                    GROUP BY cp.coupon_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':cart_id', $cart_id, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getCartx_get_y($affiliatorInfo, $cart_id) {
        $sql = "SELECT  
                    p.last_price_one,
                    p.last_price_multi ,
                    p.trademark_id , 
                    sum(cp.quantity) as quantity_sum , 
                    sum( p.{$affiliatorInfo['price_type']} * cp.quantity  )  as price_sum, 
                    sum( (ap.price - p.price)   * cp.quantity ) as sum_diffrent_price ,  
                    cp.offer_id,
                    p.active,
                    cp.product_id,
                    cp.quantity 
                FROM `cart_products` cp 
                LEFT JOIN `products` p ON p.id = cp.product_id
                LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id
                WHERE cp.cart_id = :cart_id 
                    AND cp.is_deleted = '0' 
                    AND cp.offer_id > 0 
                    AND ( cp.type != 'discount_constant'  || cp.type != 'discount_percentage' || cp.type is null  )";
        $sql .= $affiliatorInfo['price_type'] == 'price_one' ? " AND p.last_price_one > '0' " : " ";
        $sql .= $affiliatorInfo['price_type'] == 'price_multi' ? " AND p.last_price_multi >'0' " : " ";
        $sql .= " GROUP BY cp.offer_id  ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':cart_id', $cart_id);
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getProductsInCart($cart_id) {
        $sql = "SELECT 
                    cp.* , 
                    p.seller_id,
                    pl.name as product_name , 
                    pl.meta_url ,
                    p.product_barcode ,
                    p.product_code ,
                    p.price , 
                    p.price_gomla_gomla ,
                    p.price_multi , 
                    p.price_half ,
                    p.price_one  ,
                    p.commission ,
                    p.last_price_one,
                    p.last_price_multi ,
                    p.trademark_id ,  
                    ap.price as affiliator_price,
                    p.active 
                FROM `cart_products` cp
                LEFT JOIN `products` p ON p.id = cp.product_id
                LEFT JOIN `product_langs` pl ON pl.product_id = cp.product_id AND pl.lang_code = :lang_code 
                LEFT JOIN `affiliator_prices` ap ON ap.product_id = p.id
                WHERE cp.cart_id = :cart_id AND cp.is_deleted = '0'";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':lang_code', $this->lang_code);
        $stmt->bindParam(':cart_id', $cart_id);
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function handle_cart_products_groups($product_group_data, $cart_products_groups, $price, $quantity) {
        $productGroupId = $product_group_data['id'];
        $groupIds = array_column($cart_products_groups, 'id');
        $index = array_search($productGroupId, $groupIds);
        if ($index > -1) {
            if (isset($cart_products_groups[$index]['total_price'])) {
                $cart_products_groups[$index]['total_price'] += ($price * $quantity);
            } else {
                $cart_products_groups[$index]['total_price'] = ($price * $quantity);
            }
        } else {
            $cart_products_groups[] = $product_group_data;
            $lastIndex = array_key_last($cart_products_groups);
            $cart_products_groups[$lastIndex]['total_price'] = ($price * $quantity);
        }
        return $cart_products_groups;
    }

    public function getCartData($client_id, $device_id, $affiliator_id) {
        $sql = "SELECT  
                    c.id ,
                    c.cart_group_id,
                    c.invoice_edit_id,
                    c.api_invoice_edit_id,
                    c.type,
                    cp.api_id_to   
                FROM `carts` c 
                LEFT JOIN `cart_products` cp ON c.id = cp.cart_id
                WHERE (c.type='packing_in_progress' || c.type='editing_in_progress' )  
                    AND c.user_id = :affiliator_id ";
        if ($client_id) {
            $sql .= " AND c.client_id = :client_id ";
        } else {
            $sql .= " AND c.device_id = :device_id AND c.client_id = '0'  ";
        }
        $sql .= " group by c.id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        if ($client_id) {
            $stmt->bindParam(':client_id', $client_id, PDO::PARAM_INT);
        } else {
            $stmt->bindParam(':device_id', $device_id, PDO::PARAM_STR);
        }
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function emptyOfferAndCouponValue($cart_id) {
        $sql = "UPDATE `cart_products` 
                SET   
                    type = NULL ,  
                    value = '0' ,
                    quantity_offer = '0',
                    coupon_type = NULL , 
                    coupon_value = '0' ,
                    quantity_coupon = '0'
                WHERE cart_id = :cart_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':cart_id', $cart_id, PDO::PARAM_INT);
        $stmt->execute();
    }
}
