<?php

$sitemapsObj = new Sitemaps();

class Sitemaps {

    public $mDb;
    public $mConfig;
    public $lang_code;
    public $dateTime;

    public function Sitemaps() {

        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->date = date('Y-m-d');
        $this->lang_code = LANGUAGE;
    }

    public function getAllAffiliators() {
        $sql = "SELECT ao.user_id as affiliator_id,ao.front_web_url FROM affiliator_options ao  ";
        $sql .= " WHERE  (ao.`front_platfrom` = 'both' ||ao.`front_platfrom` = 'web' ) ";
        $sql .= " GROUP BY  ao.front_web_url ";
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    public function getAllPagesByAffiliatorId($affiliator_id) {
        $sql = "SELECT p.id,pl.title,p.date_added FROM pages p  ";
        $sql .= " LEFT JOIN `page_langs` pl ON p.id = pl.page_id  AND pl.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE  p.`active` = '1' and p.`affiliator_id` = '{$affiliator_id}'   ";
        $sql .= " and  p.mode='page' ";
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    function getAllIdsWithChidServiceToAffiliator($affiliator_id) {
        $sql = "SELECT afs.service_id FROM `affiliator_services` afs ";
        $sql .= " LEFT JOIN `services` s ON s.id = afs.service_id ";

        $sql .= " WHERE afs.`user_id` = '{$affiliator_id}'  AND s.active = '1' ";
// echo $sql."<hr>";

        $main = $this->mDb->getAll($sql);
        $data['main'] = fetchArrayValue_from_dataBase($main, 'service_id');

        $data['sub'] = $this->getIdsOfChidServiceIn($data['main']);
//  p( $data['sub']);
        $all_ids = '';
        if ($data['main']) {
            $all_ids .= $data['main'];
        }
        if ($data['sub']) {
            $all_ids = $all_ids ? $all_ids . "," . $data['sub'] : $data['sub'];
        }
// p($all_ids);

        return $all_ids;
    }

    function getIdsOfChidServiceIn($ids) {
        $sql = "SELECT id FROM `services`";
        $sql .= " WHERE `parent` in  ({$ids})   ";
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);

        if ($res) {
            return fetchArrayValue_from_dataBase($res, 'id');
        }
    }

    public function getAllCategorysByAffiliatorId($affiliator_id) {
        $services_ids = $this->getAllIdsWithChidServiceToAffiliator($affiliator_id);
        $sql = "SELECT s.id ,s.date_added FROM services `s`  ";
//        $sql .= " LEFT JOIN `service_langs` sl ON s.id = sl.service_id  AND sl.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE  s.`active` = '1' and s.id in({$services_ids}) ";

//      echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['lang_name'] = $this->getCategorysLangById($res[$i]['id']);
        }
//        print_r($res);
        return $res;
    }

    public function getCategorysLangById($id) {
        $sql = "SELECT lang_code , ser_name  FROM `service_langs`";
        $sql .= " WHERE `service_id` = '{$id}' ";
//         echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function getAllProductsByAffiliatorId($affiliator_id) {
        $services_ids = $this->getAllIdsWithChidServiceToAffiliator($affiliator_id);
        $sql = "SELECT p.id,p.product_barcode,p.api_archive_products,p.api_id_to,p.date_added FROM products `p`  ";
        $sql .= " LEFT JOIN `product_services` ps ON p.id = ps.product_id    ";
        $sql .= " WHERE ps.service_id in({$services_ids}) and  p.`active` != '0'  ";
        $sql .= " GROUP BY  p.id ";
        $sql .= "  ORDER BY p.date_added  DESC ";
//        $sql .= " LIMIT 0, 50 ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['lang_name'] = $this->getProductsLangById($res[$i]['id']);
            $res[$i]['images'] = $this->getProductimgs($res[$i]['id']);
        }
        return $res;
    }

    public function getProductsLangById($id) {
        $sql = "SELECT lang_code , name,meta_url  FROM `product_langs`";
        $sql .= " WHERE `product_id` = '{$id}' ";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function getProductimgs($id, $aLimit = '') {
        $time = time();
        $sql = "SELECT name ,type   FROM product_medias  ";
        $sql .= " WHERE `product_id` = '{$id}'  ";
        $sql .= $aLimit ? " LIMIT  0, {$aLimit} " : '';

        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if ($res[$i]["name"] != '') {
                $res[$i]["original_name"] = $res[$i]["name"];
                $res[$i]["name"] = $res[$i]["name"] . "?t=" . $time;
            }
        }
        return $res;
    }

    public function getAllTrademarksByAffiliatorId($affiliator_id) {
        $services_ids = $this->getAllIdsWithChidServiceToAffiliator($affiliator_id);
        $sql = "SELECT  t.id ,tl.title,t.date_added  FROM trademarks t";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id  AND  tl.lang_code = '{$this->lang_code}'  ";
        $sql .= " LEFT JOIN `products` p ON  p.trademark_id    =  t.id ";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id    ";
        $sql .= " WHERE t.id > 0 and t.active = '1'   ";
        $sql .= " AND ps.service_id  in ($services_ids)  ";

        $sql .= "  group by t.id  ORDER BY t.date_added DESC ";

        return $this->mDb->getAll($sql);
    }

    public function getAllSuggestedWordsByAffiliatorId($affiliator_id) {
        $services_ids = $this->getAllIdsWithChidServiceToAffiliator($affiliator_id);
        $sql = "SELECT  pssk.suggesstion ,'{$this->dateTime}' as date_added  FROM product_suggesstion_search_keys pssk ";
        $sql .= " LEFT JOIN `products` p ON  p.id    =  pssk.product_id ";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id    ";
        $sql .= " WHERE p.id > 0 and p.active = '1'   ";
        $sql .= " AND ps.service_id  in ($services_ids)  ";

        $sql .= "  group by pssk.suggesstion  ORDER BY pssk.id DESC ";
//echo $sql."<hr>";
        return $this->mDb->getAll($sql);
    }

    public function getAllKeyWordsByAffiliatorId($affiliator_id) {
        $services_ids = $this->getAllIdsWithChidServiceToAffiliator($affiliator_id);

        $sql = "SELECT  GROUP_CONCAT(p.key_words) AS all_keywords ";
        $sql .= "FROM products p ";
        $sql .= "LEFT JOIN `product_services` ps ON ps.product_id = p.id ";
        $sql .= "WHERE p.id > 0 AND p.active = '1' AND p.key_words != '' ";
        $sql .= "AND ps.service_id IN ($services_ids) ";
        $sql .= "GROUP BY p.id ORDER BY p.id DESC";
//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);

        $newArray = [];
        foreach ($res as $row) {
            $keywords = explode(",", $row['all_keywords']);
            $newArray = array_merge($newArray, array_filter($keywords));
        }

        $uniqueArray = array_unique($newArray);
//        p($uniqueArray);
        return $uniqueArray;
    }

    public function getAllFormShapesByAffiliatorId($affiliator_id) {
        $services_ids = $this->getAllIdsWithChidServiceToAffiliator($affiliator_id);
        $sql = "SELECT  fsol.label,fs.type ,'{$this->dateTime}' as date_added  FROM form_shape_option_langs fsol ";
        $sql .= " LEFT JOIN `product_form_shapes` pfs ON pfs.value = fsol.form_shape_option_id  ";
        $sql .= " LEFT JOIN `form_shape_options` fso ON fso.id = fsol.form_shape_option_id  ";
        $sql .= " LEFT JOIN `form_shapes` fs ON fs.id = fso.form_shape_id  ";
        $sql .= " LEFT JOIN `products` p ON  p.id    =  pfs.product_id  ";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id    ";
        $sql .= " WHERE p.id > 0 and p.active != '0'  AND  fsol.lang_code = '{$this->lang_code}' ";
        $sql .= " AND ps.service_id  in ($services_ids)  ";

        $sql .= "  group by fsol.label  ORDER BY fsol.id DESC ";
//echo $sql."<hr>";
        return $this->mDb->getAll($sql);
    }
}
